Redmine - Defect #13412

Routing error for GET "/javascripts/i18n/jquery.ui.datepicker-en-gb.js"
2013-03-09 18:03 - Harry Garrood

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version:

Resolution: Invalid Affected version:

Description

Steps to reproduce
Use en-gb locale
Create an issue
GET /issues/{id}

Log contains:

Started GET "/javascripts/il8n/jquery.ui.datepicker-en-gb.js" for 127.0.0.1 at 2013-03-09 16:51:25
+0000

ActionController::RoutingError (No route matches [GET] "/javascripts/il8n/jquery.ui.datepicker-en-
gb.js"):
actionpack (3.2.12) lib/action_dispatch/middleware/debug_exceptions.rb:21:in “call'

However there is a jguery.ui.datepicker-en-GB.js. So it appears that this asset routes are case-sensitive.

I'm not sure what the best way to go about fixing this is. Renaming the file to all downcase did fix it. Alternatively
https:/github.com/carstengehling/route_downcaser might be a solution.

History

#1 - 2013-03-09 18:04 - Harry Garrood

Ahh, | made a typo in the description and now | can't fix it! *shame*

#2 - 2013-03-09 18:07 - Harry Garrood

the route_downcaser gem won't help -- I've just noticed it ignores asset paths. (https:/github.com/carstengehling/route_downcaser#020)

#3 - 2013-03-10 17:31 - Jean-Philippe Lang
- Status changed from New to Needs feedback

- Target version set to 2.2.4

Use en-gb locale

How exactly do you use en-gb locale? If | set the language to "English (British)" in my account, | get the link to the javascript file with the proper case:

<script src="/Jjavascripts/il8n/jquery.ui.datepicker-en-GB.js?1355659332" type="text/javascript"></script>

#4 - 2013-03-10 18:24 - Harry Garrood

This is what I've done:

cd /path/to/redmine

rake db:drop db:create

# remove all plugins

rm -rf plugins/*

# I have Redmine checked out from SVN at trunk
svn revert -R .
rake db:migrate
rails s

Then:

1. Visit Redmine and log in with admin:admin

2. Go to Administration and press the 'Load default data' button. Language has defaulted to 'English (British)'
3. Create an issue

4. GET /issues/1

5. Page contains: <script src="/javascripts/i18n/jquery.ui.datepicker-en-gb.js" type="text/javascript"></script>

Some more info:

e User.find_by_login('admin').language returns an empty string.
¢ request.env[[HTTP_ACCEPT_HEADER'] in IssuesController#show returns "en-GB,en-US;g=0.8,en;q=0.6" (I'm using Chromium)
¢ echo $LANG in terminal produces en_GB.UTF-8

Setting my language to en-GB explicitly doesn't appear to have any effect.

#5 - 2013-03-10 18:28 - Harry Garrood

Oh this also probably is relevant -- here's a portion of the <select> tag in the /my/account page:

<option value="en-ind">English</option>

<option value="en-au">English</option>

<option value="en">English</option>

<option value="en-ca">English</option>

<option value="en-us">English</option>

<option value="en-bork">English</option>

<option value="en-gb">English (British)</option>
<option value="en-GB">English (British)</option>

Also, [18n.available_locales produces (non 'en* ones removed):

[... :en, :"en-GB", :"en-au", :"en-bork", :"en-ca", :"en-gb", :"en-ind", :"en-us" ...]

#6 - 2013-03-10 18:59 - Jean-Philippe Lang

Do you know where all these en-* locales come from? Redmine core only provides en and en-GB.

#7 - 2013-03-10 19:05 - Harry Garrood

| will do some investigation.

#8 - 2013-03-10 19:09 - Harry Garrood

Ah! It's because | had the faker gem in my Gemfile.local:

$ rails c

>> pp I18n.load_path
foocol
"/home/harry/.rbenv/versions/1.
"/home/harry/.rbenv/versions/1.
"/home/harry/.rbenv/versions/1.

.3-p327/1ib/ruby/gems/1.9.1/gems/faker-1.
.3-p327/1ib/ruby/gems/1.9.1/gems/faker-1.

9 .2/1lib/locales/en-gb.yml",

9
.3-p327/1ib/ruby/gems/1.9.1/gems/faker-1.

9

9

.2/1lib/locales/en-us.yml",
.2/1ib/locales/en-au.yml",
.3-p327/1ib/ruby/gems/1.9.1/gems/faker-1.1.2/1ib/locales/fr.yml",

.3-p327/1ib/ruby/gems/1.9.1/gems/faker-1.

"/home/harry/.rbenv/versions/1.
"/home/harry/.rbenv/versions/1.

Loool]
#9 - 2013-03-10 22:31 - Daniel Felix

Does everything work fine after removing this Gem? Could this issue be marked as invalid?

#10 - 2013-03-11 01:08 - Harry Garrood

.2/1lib/locales/en-ind.yml",

Everything does work fine after removing it. I'm not really sure what's going on. | guess it's not up to me to say whether the issue's invalid.

Having said that, re whether to close, | would lean towards 'no'; adding a gem to Gemfile.local shouldn't be having this effect, | don't think.

#11 - 2013-03-11 08:39 - Daniel Felix

Well, but this seem to be something which is implemented by the gem self. I've added gems to my local file too, but this worked well.

Maybe the gem itself is broken?
#12 - 2013-03-11 18:05 - Harry Garrood
Ok, | found what's causing it: https:/github.com/stympy/faker/blob/master/lib/faker.rb#l 9

Having seen that line, | don't think that's something which should be changed in Redmine. For anyone facing the same problem: put the gem into the
itest group in Gemfile.local, and then it won't mess with 118n in development or production.

This issue should probably be closed as invalid. Sorry guys.

#13 - 2013-03-11 19:31 - Jean-Philippe Lang
- Status changed from Needs feedback to Closed
- Target version deleted (2.2.4)

- Resolution set to Invalid

OK, thanks for the feedback.
